//***********************************************************************
//
//  MyWordDoc.cpp
//
//***********************************************************************

#include <afxwin.h>
#include <afxcmn.h>
#include <afxrich.h>
#include "Resource.h"
#include "MyWordDoc.h"

IMPLEMENT_DYNCREATE (CWordDoc, CRichEditDoc)

BEGIN_MESSAGE_MAP (CWordDoc, CRichEditDoc)
    ON_COMMAND (ID_FILE_SEND_MAIL, OnFileSendMail)
    ON_UPDATE_COMMAND_UI (ID_FILE_SEND_MAIL, OnUpdateFileSendMail)
END_MESSAGE_MAP ()

BOOL CWordDoc::OnNewDocument ()
{
    if (!CRichEditDoc::OnNewDocument ())
        return FALSE;

    CHARFORMAT cf;
    cf.cbSize = sizeof (CHARFORMAT);
    cf.dwMask = CFM_BOLD | CFM_ITALIC | CFM_UNDERLINE |
        CFM_PROTECTED | CFM_STRIKEOUT | CFM_FACE | CFM_SIZE;
    cf.dwEffects = 0;
    cf.yHeight = 240; // 240 twips == 12 points
    ::lstrcpy (cf.szFaceName, "Times New Roman");
    GetView ()->SetCharFormat (cf);

    return TRUE;
}

CRichEditCntrItem* CWordDoc::CreateClientItem (REOBJECT* preo) const
{
    return new CRichEditCntrItem (preo, (CWordDoc*) this);
}
